
%% (IEB) begin defining the equations in the model
model;

//Labour market
  q  = sigmam*(v/u)^(-theta);
  s  = sigmam*(v/u)^(1-theta);
  n  = (1-rho)*n(-1) + v*q;
  u  = 1 - (1-rho)*n(-1);
  ur = 1-n;
%IEB EXPLANATION: here they insert the DAC(derivative of employment adjustment
%costs, for application in robustness checks. Otherwise, these DAC=0, so
%expressions would cancel out.
kap/lambda/q  = curlphi*y - wr*(1+wrc)-DAC/n(-1) + (1-rho)*beta*lambda(+1)/lambda * kap/lambda(+1)/q(+1) + beta*lambda(+1)/lambda * DAC(+1)*n(+1)/(n^2);

// Wages %IEB MODIFIED changed to + (1-rho), and removed g from expression
tau = 1 + wrc + (dwrc/dwr)* wr
+(1-rho)*beta*lambda(+1)/lambda* dwrc(+1)*(piew(+1))^2/(pie(+1))^(1+nu);

% WAS: tau = 1 + wrc + dwrc*piew/pie^nu 
%      - (1-rho) * beta*lambda(+1)/lambda/g * dwrc(+1)*(piew(+1))^2/(pie(+1))^(1+nu);

%OK% 
omega = eta/(eta+(1-eta)*tau);

wr*(1+omega*wrc) = omega*(curlphi*y-DAC/n(-1) ...
    + (1-rho)* beta*lambda(+1)/lambda * kap/lambda(+1)/q(+1) ...
    * (1-(1-s(+1))*(1-omega)*omega(+1)/((1-omega(+1))*omega)))
    +omega*beta*lambda(+1)/lambda * DAC(+1)*n(+1)/(n^2) + (1-omega)*b;

//////////////////////////////////////////////////////////////////////////
//Employment adjustment costs 
// Quadratic + Linex
   AC  - (chin-1)/2*(n/n(-1)-1)^2 - 1/psin^2*(  exp(-psin*(n/n(-1)-1)) + psin*(n/n(-1)-1)-1);
   %IEB MODIFY changed to +2 for taking -2 down in derivative, and cancel
   %out psin with inner derivates
    DAC  - (chin-1)  *(n/n(-1)-1)   +2*(1-exp(-psin*(n/n(-1)-1)));
   %WAS:DAC  - (chin-1)  *(n/n(-1)-1)   - 1/psin  *(1-exp(-psin*(n/n(-1)-1)));

//////////////////////////////////////////////////////////////////////////
//Wage adjustment costs 
// Quadratic + Linex
   wrc  - (chiw-1)/2*(piew/pie^nu-g)^2 - 1/psiw^2*( exp(-psiw*(piew/pie^nu-g)) + psiw*(piew/pie^nu-g)-1);
   %IEB MODIFY chnaged to +2, when talking derivative and bringing down -2
   % also 1/psiw cancels out with psiw in last expression from inner
   % derivates
   dwrc - (chiw-1)  *(piew/pie^nu-g)   + 2 *(1-exp(-psiw*(piew/pie^nu-g)) );
   %WAS:dwrc  - (chiw-1)  *(piew/pie^nu-g)   - 1/psiw  *(1-exp(-psiw*(piew/pie^nu-g)) );

//////////////////////////////////////////////////////////////////////////
//Production
%IEB note, we take exp(z) becasue it's ss value is 0.
  ytot  = exp(z)*(n)^alpha * k^(1-alpha); %MISSING gamma? 
  y     = alpha*ytot/n; 
  rk    = curlphi * (1-alpha)*ytot/k; %full TobQ below, with rk + expect

//Capital
%MODIFIED MATCH PAPER, removed g
  k     = (1-delta)*k(-1) + inv; % WAS:k - (1-delta)*k(-1)/g - inv;

//////////////////////////////////////////////////////////////////////////
// Investment Adjustment costs

  IAC - (ADI-1)/2*(inv/inv(-1)-1)^2 - 1/psii^2*(  exp(-psii*(inv/inv(-1)-1)) + psii*(inv/inv(-1)-1)-1);
  %IEB MODIFY +2 when taking dervative (same as above, psii cancels out due
  %to innerderivatives)
  DAI  - (ADI-1)  *(inv/inv(-1)-1)   + 2 *(1-exp(-psii*(inv/inv(-1)-1)));
  %WAS:   DAI  - (ADI-1)  *(inv/inv(-1)-1)  - 1/psii  *(1-exp(-psii*(inv/inv(-1)-1)));

  %IEB changed last - to +
  TobQ =1 + IAC + DAI*inv/inv(-1) - beta*(lambda(+1)/lambda)*DAI(+1)*(inv(+1)/inv)^2;
  %WAS: TobQ =1 + IAC + DAI*inv/inv(-1) + beta*(lambda(+1)/lambda)*DAI(+1)*(inv(+1)/inv)^2;
  %IEB MODIFY removed g
  TobQ= rk + beta*lambda(+1)/lambda*(TobQ(+1)*(1-delta));
  %WAS: TobQ= rk + beta*lambda(+1)/lambda/g*(TobQ(+1)*(1-delta));

//////////////////////////////////////////////////////////////////////////
// Resource constraint

%IEB NOTE: AC is employment adjustment cost, included for robustness test
  c + inv = ytot*(1-gampi) - wrc*wr*n - IAC*inv - AC;

// Euler & Lagrange multiplier
%IEB MODIFY: removed g from expression
  lambda = beta*nint*exp(risk)*lambda(+1)/pie(+1);
  %WAS: lambda = beta*nint*exp(risk)*lambda(+1)/g/pie(+1);
  lambda = 1/c;

//Price Adjustment costs & Inflation Philips curve %IEB all good
  DGampi*pie = epsilon*(curlphi+gampi)-(epsilon-1) + beta*lambda(+1)/lambda* ytot(+1)/ytot * DGampi(+1) * pie(+1);
   gampi = psi/2 * (pie-1)^2;
  DGampi = psi   * (pie-1);

// Wage identity %IEB MODIFIED, removed g
 piew = (wr/wr(-1))*pie 
 % WAS: piew = g*(wr/wr(-1))*pie;

//Taylor rule reacting to inflation and output growth %IEB all good
  nint   = exp(-stdem*e_m) * (nint(-1))^omegar * (g/beta * pie^omegapi * (ytot/ytot(-1))^omegau)^(1-omegar);

// Shock process
  z     =             roz  *   z(-1) + stdez * e_z;  
  risk   =             rorisk  * risk(-1) + stderisk * (e_r);
end;